package test_entitlements_ui;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

import com.streambase.contrib.eclipse.connectivity.ISBConnection;
import com.streambase.contrib.eclipse.connectivity.SBConnectivityPlugin;
import com.streambase.sb.StreamBaseException;
import com.streambase.sb.client.StreamBaseURI;


/**
 * The activator class controls the plug-in life cycle
 */
public class TestEntitlementsUIPlugin extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "com.streambase.contrib.eclipse.entitlements.ui.sample_app";

	// The shared instance
	private static TestEntitlementsUIPlugin plugin;
	
	/**
	 * The constructor
	 */
	public TestEntitlementsUIPlugin() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}
	
	public void connect (final String server, final Shell shell) {
		try {
			ISBConnection connection = SBConnectivityPlugin.getSBConnection();
			connection.connectTo (new StreamBaseURI("sb://localhost/"));
		}
		catch (final StreamBaseException e) {
			shell.getDisplay().syncExec(new Runnable() {					
				public void run() {
					MessageDialog.openError(
							shell,
							"StreamBase Server Connection Failed",  //NON-NLS-1
							e.getMessage());
				}
			});
			System.exit(1);
		}
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static TestEntitlementsUIPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns an image descriptor for the image file at the given
	 * plug-in relative path
	 *
	 * @param path the path
	 * @return the image descriptor
	 */
	public static ImageDescriptor getImageDescriptor(String path) {
		return imageDescriptorFromPlugin(PLUGIN_ID, path);
	}
}
